from axipy import CoordSystem, Map, view_manager

from StyleTools.controls.pointStyleEditor.ui.add_tools.helper_tab import createTempTab


class MapVectroStyle:
    def __init__(self,size=300):
        max_width=int(size/2)
        str_coordsys='NonEarth Units "mm" Bounds ('+str(-max_width)+','+ str(-max_width)+') ('+str(max_width)+','+str(max_width)+') '
        self.__cur_coordsystem=CoordSystem.from_prj(str_coordsys)
        self.__initTable()
    def __initTable(self):
        self.__table_symbol=createTempTab("VectorSymbol",self.__cur_coordsystem,True)
        self.__tableXY=createTempTab("XY",self.__cur_coordsystem,True)
        self.__tableGrid = createTempTab("GridXY", self.__cur_coordsystem,True)
    def __createMap(self):
        self.__map_base=Map([self.__tableGrid,self.__tableXY,self.__table_symbol])
        '''
        layer_editable=None
        for layer in self.__map_base.layers:
            if layer.title==self.__table_symbol.name:
                layer_editable=layer
            layer.selectable=False
            layer.visible=False
        '''
        self.__map_view=view_manager.create_mapview(self.__map_base)
        layer_editable = None
        for layer in self.__map_view.map.layers:
            if layer.title == self.__table_symbol.name:
                layer_editable = layer
            layer.selectable = False
            layer.visible = False
        self.__map_view.editable_layer=layer_editable
        self.__map_view.scale_with_center(self.__cur_coordsystem.rect.width,self.__cur_coordsystem.rect.center)
    def createMapView(self):
        self.__createMap()
        return self.__map_view
